import csv  # noqa: F401
import matplotlib.pyplot as plt  # noqa: F401
from numpy.polynomial import polynomial as poly  # noqa: F401
from utils import (  # noqa: F401
    min_year, max_year)


class Country():
    def __init__(self, name, start_year, end_year):
        # Write your doc-string above, write your code below

        self.years = list(range(start_year, end_year + 1))

    def update_data(self, row):
        pass

    def get_actual_production(self, year):
        pass

    def get_production_need(self, year):
        pass

    def calculate(self):
        pass

    def plot_production_vs_consumption(self):
        pass

    def predict_need(self, predict_years):
        """
        Given a number of years to predict in the future, produces a dictionary
        containing the following keys.

            years: a list of years from the first year to the last predicted
            year
            values: a list of the predicted needs at each given year.

        For example calling:
        predict_need(data, "AMP", 5)

        will produce:
        {'years': [1961, 1962, 1963, 1964, 1965, 1966],
         'values': [10380.76, 10383.41, 10386.06, 10388.70, 10391.35,
                    10394.00]}
        """
        years = []
        needs = []
        for year in self.need:
            if self.need[year] is not None:
                years.append(year)
                needs.append(self.need[year])
        b, m = poly.polyfit(years, needs, 1)
        p_years = []
        p_need = []
        for year in range(self.years[0], self.years[-1] + predict_years + 1):
            p_years.append(year)
            p_need.append(m * year + b)
        return {"years": p_years, "values": p_need}


class Fishing():
    def __init__(self, filename):
        """
        Takes in a .csv filename and initializes an empty dictionary. Hint:
        call parse_data() to populate that dicitonary with Country objects.
        """
        # Write your code here
        pass
        # Uncomment the following line of code once you write this method
        # self.parse_data(raw_data)

    def parse_data(self, raw_data):
        pass

    def total_production_need(self, years_to_predict):
        pass
